/*
 * bsp.h
 *
 * BSP header
 */

#ifndef INCLUDED_BSP_H
#define INCLUDED_BSP_H

#include "types.h"


/*
 * Vector
 */

typedef struct
{
    float   x, y, z;
} VECTOR;

/*
 * Plane
 */

typedef struct
{
    VECTOR  unit_normal;    // unit normal pointing towards the plane
    float   dist;           // distance along unit normal from origin to plane
} PLANE;

/*
 * Vertex
 */

typedef struct
{
    float   x, y, z;
} VERTEX;

/*
 * Polygon
 */

typedef struct poly_struct
{
    INT                 valid;
    INT                 num_vertices;
    VERTEX              *vertex;
    
    struct poly_struct  *next;
} POLY;

/*
 * BSP Node
 */

typedef struct bsp_struct
{
    INT                 num_vertices;
    VERTEX              *vertex;

    struct bsp_struct   *front, *back;
} BSP;


#endif  // INCLUDED_BSP_H
