/*
 * bsp.h
 *
 * BSP header
 */

#ifndef INCLUDED_BSP_H
#define INCLUDED_BSP_H

#include "types.h"


/*
 * Vertex
 */

typedef struct
{
    float   x, y, z;
} VERTEX3D;

/*
 * Node List
 */

typedef struct node_struct
{
    VERTEX3D            *vertex;
    INT                 num_vertices;
    UINT8               color;

    INT                 id, front_id, back_id;
    
    struct node_struct  *next;
} NODE;

/*
 * BSP
 */

typedef struct bsp_struct
{
    NODE                *node;
    struct bsp_struct   *front, *back;
} BSP;


#endif  // INCLUDED_BSP_H
